package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 30/12/2018.
 */
public class Employee implements Worker, Transactable {

    private BankAccount bankAccount;

    private Double hoursWorked;

    private Double hourlyWage;

    private Double balance;

    public Employee() {
        bankAccount = new BankAccount();
        this.hoursWorked = 0.0;
        this.hourlyWage = 35.0;
        this.balance = 0.0;
        bankAccount.setBalance(0.0);


    }

    public Employee(BankAccount bankAccount) {
        setBankAccount(bankAccount);
        this.hoursWorked = 0.0;
        this.hourlyWage = 35.0;
        this.balance = bankAccount.getBalance();

    }

    public BankAccount getBankAccount() {
        return this.bankAccount;
    }

    public void setBankAccount(BankAccount bankAccount) {
        this.bankAccount = bankAccount;

    }

    @Override
    public void increaseHoursWorked(Double numberOfHours) {
        hoursWorked += numberOfHours;
    }

    @Override
    public Double getHoursWorked() {
        return hoursWorked;
    }

    @Override
    public Double getHourlyWage() {
        return hourlyWage;
    }

    @Override
    public Double getMoneyEarned() {

        Double moneyEarned = getHoursWorked() * getHourlyWage();

        return moneyEarned;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        balance += amountToIncreaseBy;
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        balance -= amountToDecreaseBy;
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}
