package rocks.zipcode.quiz5.fundamentals;

import java.util.ArrayList;
import java.util.List;

/**
 * @author leon on 21/12/2018.
 */
public class Calculator {
    public static Double squareRoot(Double value) {
        return Math.sqrt(value);
    }

    public static Double square(Double value) {

        Double sum = Math.pow(value,2);

        String str = String.format("%1.5f", sum);
        sum = Double.valueOf(str);
        System.out.println(sum);

        return sum;
    }

    public static Double[] squareRoots(Double... value) {

        List<Double> list = new ArrayList<>();

        for(Double v: value){
            list.add(squareRoot(v));
        }

        return list.toArray(new Double[0]);
    }

    public static Double[] squares(Double... values) {
        List<Double> list = new ArrayList<>();

        for(Double v: values){
            list.add(square(v));
        }

        return list.toArray(new Double[0]);
    }

    public static Double add(Double value1, Double value2) {

        Double sum = value1 + value2;
        String str = String.format("%1.2f", sum);
        sum = Double.valueOf(str);
        System.out.println(sum);

        return sum;
    }

    public static Double subtract(Double value1, Double value2) {
        return value1 - value2;
    }


    public static Double divide(Double divisor, Double dividend) {
        return divisor/dividend;
    }
}
