package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {

        return string.charAt(string.length()/2);
    }

    public static String capitalizeMiddleCharacter(String str) {

        String[] letters = str.split("");
        StringBuilder builder = new StringBuilder();

        for(int i =0; i < letters.length; i++){
            if(i == letters.length/2){
                builder.append(letters[i].toUpperCase());
            }else {
                builder.append(letters[i]);
            }
            }

        return builder.toString();
    }

    public static String lowerCaseMiddleCharacter(String str) {

        String[] letters = str.split("");
        StringBuilder builder = new StringBuilder();

        for(int i =0; i < letters.length; i++){
            if(i == letters.length/2){
                builder.append(letters[i].toLowerCase());
            }else {
                builder.append(letters[i]);
            }
        }

        return builder.toString();
    }

    public static Boolean isIsogram(String str) {

        char arr[] = str.toCharArray();

        Arrays.sort(arr);
        for (int i = 0; i < str.length() - 1; i++) {
            if (arr[i] == arr[i + 1])
                return false;
        }
        return true;
    }


    public static Boolean hasDuplicateConsecutiveCharacters(String str) {
        char arr[] = str.toCharArray();

        for(int i = 0; i < arr.length-1; i++){
            if(arr[i] == arr[i+1]){
                return true;
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {

        String[] arr = str.split("");

        String letter = arr[0];

        for(int i =1; i < arr.length; i++){
            String next = arr[i];
            if(letter.equals(next)){
                arr[i] = "";
                arr[i-1] = "";
            }
            else{
                letter = arr[i];
            }
        }

        StringBuilder builder = new StringBuilder();
        for(int i = 0; i <arr.length; i++){
            builder.append(arr[i]);
        }

        return builder.toString();

    }

    public static String invertCasing(String str) {

        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++)
        {
            char c = chars[i];
            if (Character.isUpperCase(c))
            {
                chars[i] = Character.toLowerCase(c);
            }
            else if (Character.isLowerCase(c))
            {
                chars[i] = Character.toUpperCase(c);
            }
        }
        return new String(chars);
    }
}